#<profile4xi profile = "11" /> 
# -------------------------------------------------------------------------------------------------
#<program4xi program = "fire1500eight4xi.py">
#<abstract4xi abstract = "fires to direction eight and to distance 1500"/>
#<verify4xi verification = "11" target = "verb4xi.py"/>
#<refer4xi reference = "verb4xi.py"/>
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting; [Rel 7.21]"/>
# -------------------------------------------------------------------------------------------------

# -------------------------------------------------------------------------------------------------
# Public API
# -------------------------------------------------------------------------------------------------
#<interface4xi interface = " 
__all__ = [ 'fire2eight4xi']
#"
#/>


# -------------------------------------------------------------------------------------------------
# Standard Imports                          
# -------------------------------------------------------------------------------------------------
#<standardize4xi standard = "
import os
import sys
import threading                
import _thread
import _winapi
   

import signal
import itertools
import weakref
import logging 

from math import pi
from math import sin
from math import cos 
from math import fabs
#"
#/>

# -------------------------------------------------------------------------------------------------
# DragonXi imports                              
# -------------------------------------------------------------------------------------------------
#<dragonize4xi dragonization = "


from time4xi import time4xi

#"
#/>
       
       
# -------------------------------------------------------------------------------------------------
# SHOT2EIGHT - COORDINATE SIGNS OF SHOOT2EIGHT4XI: (X - ,Y - ,Z -)
# -------------------------------------------------------------------------------------------------    
global shot2eight15004xi

#"
#/>

# -------------------------------------------------------------------------------------------------
# Settings
# -------------------------------------------------------------------------------------------------
#<set4xi setting = "
ack2debug = True
         
shot2eight15004xi = {
                1:'-100x-1004y-1109z',
                2:'-1027x-1092y0z',
                3:'-1028x-601y-911z',
                4:'-1038x-772y-758z',
                5:'-1066x-550y-899z',
                6:'-107x-1151y-954z',
                7:'-1083x-721y-745z',
                8:'-1102x-497y-887z',
                9:'-110x-1483y-194z',
                10:'-110x-503y-1408z',
                11:'-1126x-667y-732z',
                12:'-1135x-442y-874z',
                13:'-115x-287y-1467z',
                14:'-1165x-385y-862z',
                15:'-1166x-610y-718z',
                16:'-1191x-326y-850z',
                17:'-1202x-552y-705z',
                18:'-1215x-265y-838z',
                19:'-1235x-202y-825z',
                20:'-1236x-490y-692z',
                21:'-1252x-138y-812z',
                22:'-1267x-427y-679z',
                23:'-1294x-362y-665z',
                24:'-1317x-295y-652z',
                25:'-136x-294y-1464z',
                26:'-140x-510y-1403z',
                27:'-14x-220y-1483z',
                28:'-154x-1008y-1099z',
                29:'-158x-299y-1461z',
                30:'-169x-1154y-943z',
                31:'-171x-515y-1397z',
                32:'-181x-303y-1457z',
                33:'-188x-1477y-179z',
                34:'-203x-519y-1392z',
                35:'-205x-305y-1454z',
                36:'-209x-1009y-1089z',
                37:'-229x-306y-1450z',
                38:'-231x-1152y-931z',
                39:'-236x-520y-1386z',
                40:'-254x-304y-1446z',
                41:'-264x-1007y-1078z',
                42:'-265x-1467y-164z',
                43:'-269x-519y-1381z',
                44:'-280x-301y-1442z',
                45:'-28x-234y-1481z',
                46:'-293x-1148y-919z',
                47:'-303x-516y-1375z',
                48:'-305x-296y-1438z',
                49:'-320x-1002y-1068z',
                50:'-32x-1484y-209z',
                51:'-331x-289y-1433z',
                52:'-337x-511y-1369z',
                53:'-342x-1452y-149z',
                54:'-356x-1139y-907z',
                55:'-357x-280y-1429z',
                56:'-372x-504y-1362z',
                57:'-375x-994y-1057z',
                58:'-383x-269y-1424z',
                59:'-3x-206y-1485z',
                60:'-406x-494y-1356z',
                61:'-409x-257y-1420z',
                62:'-418x-1128y-895z',
                63:'-418x-1434y-134z',
                64:'-42x-247y-1478z',
                65:'-431x-983y-1047z',
                66:'-434x-242y-1415z',
                67:'-441x-482y-1350z',
                68:'-459x-225y-1410z',
                69:'-475x-468y-1343z',
                70:'-47x-1146y-966z',
                71:'-47x-996y-1119z',
                72:'-480x-1112y-883z',
                73:'-483x-206y-1404z',
                74:'-487x-968y-1036z',
                75:'-493x-1411y-119z',
                76:'-506x-185y-1399z',
                77:'-509x-451y-1336z',
                78:'-529x-163y-1394z',
                79:'-541x-1094y-871z',
                80:'-542x-432y-1329z',
                81:'-542x-950y-1025z',
                82:'-550x-138y-1388z',
                83:'-566x-1384y-104z',
                84:'-570x-112y-1382z',
                85:'-575x-411y-1322z',
                86:'-589x-84y-1376z',
                87:'-58x-516y-1513z',
                88:'-596x-929y-1014z',
                89:'-59x-258y-1476z',
                90:'-602x-1071y-859z',
                91:'-606x-54y-1370z',
                92:'-607x-387y-1315z',
                93:'-637x-362y-1308z',
                94:'-638x-1354y-89z',
                95:'-650x-905y-1003z',
                96:'-662x-1045y-846z',
                97:'-667x-333y-1301z',
                98:'-696x-303y-1293z',
                99:'-703x-877y-992z',
                100:'-709x-1319y-74z',
                101:'-721x-1016y-834z',
                102:'-723x-271y-1285z',
                103:'-748x-237y-1278z',
                104:'-754x-847y-980z',
                105:'-76x-269y-1473z',
                106:'-772x-200y-1270z',
                107:'-777x-1281y-59z',
                108:'-778x-984y-821z',
                109:'-805x-813y-969z',
                110:'-82x-494y-1413z',
                111:'-834x-948y-809z',
                112:'-843x-1239y-44z',
                113:'-853x-776y-958z',
                114:'-888x-908y-796z',
                115:'-900x-737y-946z',
                116:'-907x-1193y-29z',
                117:'-940x-866y-783z',
                118:'-945x-694y-934z',
                119:'-95x-279y-1470z',
                120:'-969x-1144y-14z',
                121:'-988x-649y-922z',
                122:'-990x-821y-771z'}

#"
#/>


# -------------------------------------------------------------------------------------------------
#<function4xi function = "fire1500eight4xi" usage = "target function for charge1500eight4xi with Process4Xi">
#<state4xi status = "ACK4tagging; ACK4moduletesting; NACK4systemtesting"/>
# -------------------------------------------------------------------------------------------------
def fire1500eight4xi(queue2eight, consumer_channel2eight, publisher_channel2eight):
    '''
    returns (x,y,z) coordinates via queue
    '''
    
    # -------------------------------------------------------------------------------------------------
    # PARAMETERS                   
    # -------------------------------------------------------------------------------------------------                                                               
    
    time2start = time4xi()
    if ack2debug is True:
        print("\n (STEP 1A1/33) OF FIRE1500EIGHT4XI - STARTED TIME: ", time2start)
        # 
        
        print("\n (STEP 1A2/33) OF FIRE1500EIGHT4XI -  QUEUE2EIGHT: ", queue2eight)      
        # 
        
        print("\n (STEP 1A3/33) OF FIRE1500EIGHT4XI -  CONSUMER_CHANNEL2EIGHT: ", consumer_channel2eight)
        # 
              
        print("\n (STEP 1A4/33) OF FIRE1500EIGHT4XI -  PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight)          
        # 
        


    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    # QUEUE RETURNING
    # ~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
    ack2put = False
    if ack2debug is True:
        print("\n (STEP 2A/33) OF FIRE1500EIGHT4XI - TRYING TO RETURN BY PUTTING COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
        # 
         
    try:
        # ------------------------------------------------------------------------------------- 
        # PUT SHOT TO QUEUE 
        # -------------------------------------------------------------------------------------                 
        queue2eight.put(shot2eight15004xi)
        if ack2debug is True:
            print("\n (STEP 2B/33) OF FIRE1500EIGHT4XI - SUCCEEDED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
            # 
             
        ack2put = True
    except:
        print("\n (STEP 2C/33) OF FIRE1500EIGHT4XI *** FAILED TO PUT COORDINATE DICTIONARY TO QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:
        print("\n (STEP 3A/33) OF FIRE1500EIGHT4XI - TRYING TO INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi())
        # 
         
    try:                
        # ---------------------------------------------------------------------------------------------
        # INFORM PUT OPERATIONS VIA PIPE'S PUBLISHER CHANNEL 
        # ---------------------------------------------------------------------------------------------
        if ack2put is True:
            message2send4one = "<ack2put4xi>queue2eight8shot2eight15004xi</ack2put4xi>"
        else:
            message2send4one = "<nack2put4xi>queue2eight8shot2eight15004xi</nack2put4xi>" 
            
        publisher_channel2eight.send(message2send4one)
        if ack2debug is True:    
            print(" (STEP 3B/33) OF FIRE1500EIGHT4XI -  SENT MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
            #  
        
    except:
        print(" (STEP 3C/33) OF FIRE1500EIGHT4XI *** FAILED TO SEND MESSAGE2SEND4ONE: ", message2send4one, " TO PUBLISHER_CHANNEL2EIGHT: ", publisher_channel2eight, " - TIME: ", time4xi()) 
    
    if ack2debug is True:        
        print("\n (STEP 3D/33) OF FIRE1500EIGHT4XI - RETURNING QUEUE OBJECT QUEUE2EIGHT: ", queue2eight, " - TIME: ", time4xi())  
        # 
            
    return queue2eight    
        
           
#</function4xi>


#</program4xi>
# -------------------------------------------------------------------------------------------------
# Recorded History                             
# ------------------------------------------------------------------------------------------------- 
#<record4xi record = "
#   test_verb4xi.txt
#   sense-test-verb4xi.xml
#   reason-test-verb4xi.xml
#   ace-test-verb4xi.xml
#"
#>

# -------------------------------------------------------------------------------------------------
# Legal Notice                             
# ------------------------------------------------------------------------------------------------- 
#<protect4xi protection = "copyright"
#   owner = "Small & Smart"
#   rights = "All rights reserved"
#   state = "California"
#   country = "United States of America"
#   references = "Legal notice at www.dragonxi.com; www.yourdragonxi.com; www.yourdragonxi.org; www.dragon2xi.com/; www.dragon4xi.com/; www.dragon8xi.com/ " 
#   codes = "Codes established in California and applicable to corporations in California"
#   compliance = "The California Law"
#   court = "Supreme Court of California, 350 McAllister Street, San Francisco, CA 94102-4783"
#/>

#<end4xi end = "
# -------------------------------------------------------------------------------------------------
# end of fire1500eight4xi.py                             
# ------------------------------------------------------------------------------------------------- 
#"
#/>
                                  